diff --git a/src/usr/local/www/firewall_rules_edit.php b/src/usr/local/www/firewall_rules_edit.php
index 3db8f720bb..ac86dc8162 100644
--- a/src/usr/local/www/firewall_rules_edit.php
+++ b/src/usr/local/www/firewall_rules_edit.php
@@ -139,10 +139,7 @@ foreach ($ifdisp as $kif => $kdescr) {
 	$specialsrcdst[] = "{$kif}ip";
 }
 
-if (!is_array($config['filter']['rule'])) {
-	$config['filter']['rule'] = array();
-}
-
+init_config_arr(array('filter', 'rule'));
 filter_rules_sort();
 $a_filter = &$config['filter']['rule'];
 
@@ -608,7 +605,7 @@ if ($_POST['save']) {
 	}
 
 	if ($_POST['proto'] == "icmp") {
-		$t =& $_POST['icmptype'];
+		$t = $_POST['icmptype'];
 		if (isset($t) && !is_array($t)) {
 			// shouldn't happen but avoids making assumptions for data-sanitising
 			$input_errors[] = gettext("ICMP types expected to be a list if present, but is not.");
@@ -965,6 +962,7 @@ if ($_POST['save']) {
 				$a_filter[$id] = $filterent;
 			} else {							// rule moved to different interface
 				// Update the separators of previous interface.
+				init_config_arr(array('filter', 'separator', strtolower($if)));
 				$a_separators = &$config['filter']['separator'][strtolower($if)];
 				$ridx = ifridx($if, $id);		// get rule index within interface
 				$mvnrows = -1;
@@ -973,6 +971,7 @@ if ($_POST['save']) {
 				$a_filter[$id] = $filterent;	// save edited rule to new interface
 
 				// Update the separators of new interface.
+				init_config_arr(array('filter', 'separator', strtolower($tmpif)));
 				$a_separators = &$config['filter']['separator'][strtolower($tmpif)];
 				$ridx = ifridx($tmpif, $id);	// get rule index within interface
 				if ($ridx == 0) {				// rule was placed at the top
@@ -1004,6 +1003,7 @@ if ($_POST['save']) {
 				}
 
 				// Update the separators
+				init_config_arr(array('filter', 'separator', strtolower($tmpif)));
 				$a_separators = &$config['filter']['separator'][strtolower($tmpif)];
 				$ridx = ifridx($tmpif, $after);	// get rule index within interface
 				$mvnrows = +1;
diff --git a/src/usr/local/www/firewall_virtual_ip.php b/src/usr/local/www/firewall_virtual_ip.php
index 11ad2b9926..50c8bfaa07 100644
--- a/src/usr/local/www/firewall_virtual_ip.php
+++ b/src/usr/local/www/firewall_virtual_ip.php
@@ -36,14 +36,7 @@ require_once("functions.inc");
 require_once("filter.inc");
 require_once("shaper.inc");
 
-if (!is_array($config['virtualip'])) {
-	$config['virtualip'] = array();
-}
-
-if (!is_array($config['virtualip']['vip'])) {
-	$config['virtualip']['vip'] = array();
-}
-
+init_config_arr(array('virtualip', 'vip'));
 $a_vip = &$config['virtualip']['vip'];
 
 if ($_POST['apply']) {
diff --git a/src/usr/local/www/firewall_virtual_ip_edit.php b/src/usr/local/www/firewall_virtual_ip_edit.php
index 9e65b43adb..53de79097c 100644
--- a/src/usr/local/www/firewall_virtual_ip_edit.php
+++ b/src/usr/local/www/firewall_virtual_ip_edit.php
@@ -35,14 +35,7 @@ require_once("guiconfig.inc");
 require_once("filter.inc");
 require_once("shaper.inc");
 
-if (!is_array($config['virtualip'])) {
-		$config['virtualip'] = array();
-}
-
-if (!is_array($config['virtualip']['vip'])) {
-		$config['virtualip']['vip'] = array();
-}
-
+init_config_arr(array('virtualip', 'vip'));
 $a_vip = &$config['virtualip']['vip'];
 
 if (isset($_REQUEST['id']) && is_numericint($_REQUEST['id'])) {
diff --git a/src/usr/local/www/interfaces.php b/src/usr/local/www/interfaces.php
index 056713be26..b60da90d39 100755
--- a/src/usr/local/www/interfaces.php
+++ b/src/usr/local/www/interfaces.php
@@ -41,6 +41,10 @@ require_once("rrd.inc");
 require_once("vpn.inc");
 require_once("xmlparse_attr.inc");
 
+function remove_bad_chars($string) {
+	return preg_replace('/[^a-z_0-9]/i', '', $string);
+}
+
 define("ANTENNAS", false);
 
 if (isset($_POST['referer'])) {
@@ -72,26 +76,10 @@ if (!is_array($pconfig)) {
 	$pconfig = array();
 }
 
-if (!is_array($config['ppps'])) {
-	$config['ppps'] = array();
-}
-if (!is_array($config['ppps']['ppp'])) {
-	$config['ppps']['ppp'] = array();
-}
+init_config_arr(array('ppps', 'ppp'));
 $a_ppps = &$config['ppps']['ppp'];
 
-function remove_bad_chars($string) {
-	return preg_replace('/[^a-z_0-9]/i', '', $string);
-}
-
-if (!is_array($config['gateways'])) {
-	$config['gateways'] = array();
-}
-
-if (!is_array($config['gateways']['gateway_item'])) {
-	$config['gateways']['gateway_item'] = array();
-}
-
+init_config_arr(array('gateways', 'gateway_item'));
 $a_gateways = &$config['gateways']['gateway_item'];
 
 $interfaces = get_configured_interface_with_descr();
@@ -106,6 +94,7 @@ foreach ($no_address_interfaces as $ifbl) {
 	}
 }
 
+init_config_arr(array('interfaces', $if));
 $wancfg = &$config['interfaces'][$if];
 $old_wancfg = $wancfg;
 $old_wancfg['realif'] = get_real_interface($if);
diff --git a/src/usr/local/www/interfaces_bridge.php b/src/usr/local/www/interfaces_bridge.php
index 5e45ea284e..f4147e8450 100644
--- a/src/usr/local/www/interfaces_bridge.php
+++ b/src/usr/local/www/interfaces_bridge.php
@@ -28,15 +28,8 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['bridges'])) {
-	$config['bridges'] = array();
-}
-
-if (!is_array($config['bridges']['bridged'])) {
-	$config['bridges']['bridged'] = array();
-}
-
-$a_bridges = &$config['bridges']['bridged'] ;
+init_config_arr(array('bridges', 'bridged'));
+$a_bridges = &$config['bridges']['bridged'];
 
 function bridge_inuse($num) {
 	global $config, $a_bridges;
diff --git a/src/usr/local/www/interfaces_bridge_edit.php b/src/usr/local/www/interfaces_bridge_edit.php
index 9476ade24f..c025c1484c 100644
--- a/src/usr/local/www/interfaces_bridge_edit.php
+++ b/src/usr/local/www/interfaces_bridge_edit.php
@@ -28,14 +28,6 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['bridges'])) {
-	$config['bridges'] = array();
-}
-
-if (!is_array($config['bridges']['bridged'])) {
-	$config['bridges']['bridged'] = array();
-}
-
 function is_aoadv_used($pconfig) {
 	if (($pconfig['static'] !="") ||
 	    ($pconfig['private'] != "") ||
@@ -60,6 +52,7 @@ function is_aoadv_used($pconfig) {
 	return false;
 }
 
+init_config_arr(array('bridges', 'bridged'));
 $a_bridges = &$config['bridges']['bridged'];
 
 $ifacelist = get_configured_interface_with_descr();
diff --git a/src/usr/local/www/interfaces_gif.php b/src/usr/local/www/interfaces_gif.php
index 91cc20bf9d..53739c88dd 100644
--- a/src/usr/local/www/interfaces_gif.php
+++ b/src/usr/local/www/interfaces_gif.php
@@ -28,13 +28,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['gifs'])) {
-	$config['gifs'] = array();
-}
-if (!is_array($config['gifs']['gif'])) {
-	$config['gifs']['gif'] = array();
-}
-
+init_config_arr(array('gifs', 'gif'));
 $a_gifs = &$config['gifs']['gif'] ;
 
 function gif_inuse($num) {
diff --git a/src/usr/local/www/interfaces_gif_edit.php b/src/usr/local/www/interfaces_gif_edit.php
index 18ff9af329..f8e87328db 100644
--- a/src/usr/local/www/interfaces_gif_edit.php
+++ b/src/usr/local/www/interfaces_gif_edit.php
@@ -28,13 +28,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['gifs'])) {
-	$config['gifs'] = array();
-}
-if (!is_array($config['gifs']['gif'])) {
-	$config['gifs']['gif'] = array();
-}
-
+init_config_arr(array('gifs', 'gif'));
 $a_gifs = &$config['gifs']['gif'];
 $id = $_REQUEST['id'];
 
diff --git a/src/usr/local/www/interfaces_gre.php b/src/usr/local/www/interfaces_gre.php
index a5833defaf..62ca5d8636 100644
--- a/src/usr/local/www/interfaces_gre.php
+++ b/src/usr/local/www/interfaces_gre.php
@@ -29,13 +29,7 @@
 require_once("guiconfig.inc");
 require_once("functions.inc");
 
-if (!is_array($config['gres'])) {
-	$config['gres'] = array();
-}
-if (!is_array($config['gres']['gre'])) {
-	$config['gres']['gre'] = array();
-}
-
+init_config_arr(array('gres', 'gre'));
 $a_gres = &$config['gres']['gre'] ;
 
 function gre_inuse($num) {
diff --git a/src/usr/local/www/interfaces_gre_edit.php b/src/usr/local/www/interfaces_gre_edit.php
index a46603e875..c624c32cac 100644
--- a/src/usr/local/www/interfaces_gre_edit.php
+++ b/src/usr/local/www/interfaces_gre_edit.php
@@ -29,13 +29,7 @@
 require_once("guiconfig.inc");
 require_once("functions.inc");
 
-if (!is_array($config['gres'])) {
-	$config['gres'] = array();
-}
-if (!is_array($config['gres']['gre'])) {
-	$config['gres']['gre'] = array();
-}
-
+init_config_arr(array('gres', 'gre'));
 $a_gres = &$config['gres']['gre'];
 $id = $_REQUEST['id'];
 
diff --git a/src/usr/local/www/interfaces_groups.php b/src/usr/local/www/interfaces_groups.php
index c9dee04206..cec72e2bde 100644
--- a/src/usr/local/www/interfaces_groups.php
+++ b/src/usr/local/www/interfaces_groups.php
@@ -29,14 +29,7 @@
 require_once("guiconfig.inc");
 require_once("functions.inc");
 
-if (!is_array($config['ifgroups'])) {
-	$config['ifgroups'] = array();
-}
-
-if (!is_array($config['ifgroups']['ifgroupentry'])) {
-	$config['ifgroups']['ifgroupentry'] = array();
-}
-
+init_config_arr(array('ifgroups', 'ifgroupentry'));
 $a_ifgroups = &$config['ifgroups']['ifgroupentry'];
 
 if ($_POST['act'] == "del") {
diff --git a/src/usr/local/www/interfaces_groups_edit.php b/src/usr/local/www/interfaces_groups_edit.php
index 141267ef03..d55dc2cefa 100644
--- a/src/usr/local/www/interfaces_groups_edit.php
+++ b/src/usr/local/www/interfaces_groups_edit.php
@@ -34,14 +34,7 @@ $pgtitle = array(gettext("Interfaces"), gettext("Interface Groups"), gettext("Ed
 $pglinks = array("", "interfaces_groups.php", "@self");
 $shortcut_section = "interfaces";
 
-if (!is_array($config['ifgroups'])) {
-	$config['ifgroups'] = array();
-}
-
-if (!is_array($config['ifgroups']['ifgroupentry'])) {
-	$config['ifgroups']['ifgroupentry'] = array();
-}
-
+init_config_arr(array('ifgroups', 'ifgroupentry'));
 $a_ifgroups = &$config['ifgroups']['ifgroupentry'];
 $id = $_REQUEST['id'];
 
diff --git a/src/usr/local/www/interfaces_lagg.php b/src/usr/local/www/interfaces_lagg.php
index 591f62e069..f7d2d6e0a2 100644
--- a/src/usr/local/www/interfaces_lagg.php
+++ b/src/usr/local/www/interfaces_lagg.php
@@ -28,14 +28,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['laggs'])) {
-	$config['laggs'] = array();
-}
-
-if (!is_array($config['laggs']['lagg'])) {
-	$config['laggs']['lagg'] = array();
-}
-
+init_config_arr(array('laggs', 'lagg'));
 $a_laggs = &$config['laggs']['lagg'] ;
 
 function lagg_inuse($num) {
diff --git a/src/usr/local/www/interfaces_lagg_edit.php b/src/usr/local/www/interfaces_lagg_edit.php
index f88480873a..2a98d27613 100644
--- a/src/usr/local/www/interfaces_lagg_edit.php
+++ b/src/usr/local/www/interfaces_lagg_edit.php
@@ -28,14 +28,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['laggs'])) {
-	$config['laggs'] = array();
-}
-
-if (!is_array($config['laggs']['lagg'])) {
-	$config['laggs']['lagg'] = array();
-}
-
+init_config_arr(array('laggs', 'lagg'));
 $a_laggs = &$config['laggs']['lagg'];
 
 $portlist = get_interface_list();
diff --git a/src/usr/local/www/interfaces_ppps_edit.php b/src/usr/local/www/interfaces_ppps_edit.php
index d3a27d1818..6eb5f115a5 100644
--- a/src/usr/local/www/interfaces_ppps_edit.php
+++ b/src/usr/local/www/interfaces_ppps_edit.php
@@ -39,14 +39,7 @@ define("CRON_WEEKLY_PATTERN", "0 0 * * 0");
 define("CRON_DAILY_PATTERN", "0 0 * * *");
 define("CRON_HOURLY_PATTERN", "0 * * * *");
 
-if (!is_array($config['ppps'])) {
-	$config['ppps'] = array();
-}
-
-if (!is_array($config['ppps']['ppp'])) {
-	$config['ppps']['ppp'] = array();
-}
-
+init_config_arr(array('ppps', 'ppp'));
 $a_ppps = &$config['ppps']['ppp'];
 
 $iflist = get_configured_interface_with_descr();
@@ -470,7 +463,6 @@ $types = array("select" => gettext("Select"), "ppp" => gettext("PPP"), "pppoe" =
 $serviceproviders_xml = "/usr/local/share/mobile-broadband-provider-info/serviceproviders.xml";
 $serviceproviders_contents = file_get_contents($serviceproviders_xml);
 $serviceproviders_attr = xml2array($serviceproviders_contents, 1, "attr");
-
 $serviceproviders = &$serviceproviders_attr['serviceproviders']['country'];
 
 //print_r($serviceproviders);
diff --git a/src/usr/local/www/interfaces_vlan.php b/src/usr/local/www/interfaces_vlan.php
index ccda74eb5d..b0a53c97e2 100644
--- a/src/usr/local/www/interfaces_vlan.php
+++ b/src/usr/local/www/interfaces_vlan.php
@@ -35,15 +35,8 @@ require_once("interfaces_fast.inc");
 
 global $profile;
 
-if (!is_array($config['vlans'])) {
-	$config['vlans'] = array();
-}
-
-if (!is_array($config['vlans']['vlan'])) {
-	$config['vlans']['vlan'] = array();
-}
-
-$a_vlans = &$config['vlans']['vlan'] ;
+init_config_arr(array('vlans', 'vlan'));
+$a_vlans = &$config['vlans']['vlan'];
 
 if ($_POST['act'] == "del") {
 	if (!isset($_POST['id'])) {
diff --git a/src/usr/local/www/interfaces_vlan_edit.php b/src/usr/local/www/interfaces_vlan_edit.php
index 23ea5a09d4..5dcc34207f 100644
--- a/src/usr/local/www/interfaces_vlan_edit.php
+++ b/src/usr/local/www/interfaces_vlan_edit.php
@@ -32,13 +32,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['vlans'])) {
-	$config['vlans'] = array();
-}
-if (!is_array($config['vlans']['vlan'])) {
-	$config['vlans']['vlan'] = array();
-}
-
+init_config_arr(array('vlans', 'vlan'));
 $a_vlans = &$config['vlans']['vlan'];
 
 $portlist = get_interface_list();
diff --git a/src/usr/local/www/interfaces_wireless.php b/src/usr/local/www/interfaces_wireless.php
index 12e0c27043..f701f1fcf4 100644
--- a/src/usr/local/www/interfaces_wireless.php
+++ b/src/usr/local/www/interfaces_wireless.php
@@ -29,13 +29,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['wireless'])) {
-	$config['wireless'] = array();
-}
-if (!is_array($config['wireless']['clone'])) {
-	$config['wireless']['clone'] = array();
-}
-
+init_config_arr(array('wireless', 'clone'));
 $a_clones = &$config['wireless']['clone'];
 
 function clone_inuse($num) {
diff --git a/src/usr/local/www/interfaces_wireless_edit.php b/src/usr/local/www/interfaces_wireless_edit.php
index b78a71a822..22d88bdd1f 100644
--- a/src/usr/local/www/interfaces_wireless_edit.php
+++ b/src/usr/local/www/interfaces_wireless_edit.php
@@ -29,14 +29,7 @@
 
 require_once("guiconfig.inc");
 
-if (!is_array($config['wireless'])) {
-	$config['wireless'] = array();
-}
-
-if (!is_array($config['wireless']['clone'])) {
-	$config['wireless']['clone'] = array();
-}
-
+init_config_arr(array('wireless', 'clone'));
 $a_clones = &$config['wireless']['clone'];
 
 function clone_inuse($num) {
diff --git a/src/usr/local/www/load_balancer_monitor.php b/src/usr/local/www/load_balancer_monitor.php
index d8b3433fad..ae55ea5f9e 100644
--- a/src/usr/local/www/load_balancer_monitor.php
+++ b/src/usr/local/www/load_balancer_monitor.php
@@ -30,9 +30,7 @@
 require_once("guiconfig.inc");
 require_once("filter.inc");
 
-if (!is_array($config['load_balancer']['monitor_type'])) {
-	$config['load_balancer']['monitor_type'] = array();
-}
+init_config_arr(array('load_balancer', 'monitor_type'));
 $a_monitor = &$config['load_balancer']['monitor_type'];
 
 $pconfig = $_POST;
diff --git a/src/usr/local/www/load_balancer_monitor_edit.php b/src/usr/local/www/load_balancer_monitor_edit.php
index 8865513e0a..0185c89d6a 100644
--- a/src/usr/local/www/load_balancer_monitor_edit.php
+++ b/src/usr/local/www/load_balancer_monitor_edit.php
@@ -31,10 +31,7 @@ require_once("guiconfig.inc");
 
 $referer = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '/load_balancer_monitor.php');
 
-if (!is_array($config['load_balancer']['monitor_type'])) {
-	$config['load_balancer']['monitor_type'] = array();
-}
-
+init_config_arr(array('load_balancer', 'monitor_type'));
 $a_monitor = &$config['load_balancer']['monitor_type'];
 $id = $_REQUEST['id'];
 
diff --git a/src/usr/local/www/load_balancer_pool.php b/src/usr/local/www/load_balancer_pool.php
index ad437c1f47..cd4a3f598a 100644
--- a/src/usr/local/www/load_balancer_pool.php
+++ b/src/usr/local/www/load_balancer_pool.php
@@ -32,10 +32,7 @@ require_once("functions.inc");
 require_once("filter.inc");
 require_once("shaper.inc");
 
-if (!is_array($config['load_balancer']['lbpool'])) {
-	$config['load_balancer']['lbpool'] = array();
-}
-
+init_config_arr(array('load_balancer', 'lbpool'));
 $a_pool = &$config['load_balancer']['lbpool'];
 
 $pconfig = $_POST;
diff --git a/src/usr/local/www/load_balancer_pool_edit.php b/src/usr/local/www/load_balancer_pool_edit.php
index aa639a59ba..539686151f 100644
--- a/src/usr/local/www/load_balancer_pool_edit.php
+++ b/src/usr/local/www/load_balancer_pool_edit.php
@@ -33,16 +33,13 @@ require_once("util.inc");
 
 $referer = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '/load_balancer_pool.php');
 
-if (!is_array($config['load_balancer']['lbpool'])) {
-	$config['load_balancer']['lbpool'] = array();
-}
-
+init_config_arr(array('load_balancer', 'lbpool'));
 $a_pool = &$config['load_balancer']['lbpool'];
 
 $id = $_REQUEST['id'];
 
-
 if (isset($id) && $a_pool[$id]) {
+	init_config_arr(array('load_balancer', 'lbpool', $id));
 	$pconfig['name'] = $a_pool[$id]['name'];
 	$pconfig['mode'] = $a_pool[$id]['mode'];
 	$pconfig['descr'] = $a_pool[$id]['descr'];
diff --git a/src/usr/local/www/load_balancer_setting.php b/src/usr/local/www/load_balancer_setting.php
index b563ac4f3c..6592d847d4 100644
--- a/src/usr/local/www/load_balancer_setting.php
+++ b/src/usr/local/www/load_balancer_setting.php
@@ -34,10 +34,7 @@ require_once("filter.inc");
 require_once("shaper.inc");
 require_once("util.inc");
 
-if (!is_array($config['load_balancer']['setting'])) {
-	$config['load_balancer']['setting'] = array();
-}
-
+init_config_arr(array('load_balancer', 'setting'));
 $lbsetting = &$config['load_balancer']['setting'];
 
 if ($_POST) {
diff --git a/src/usr/local/www/load_balancer_virtual_server.php b/src/usr/local/www/load_balancer_virtual_server.php
index faa637f6b5..907b6dd30c 100644
--- a/src/usr/local/www/load_balancer_virtual_server.php
+++ b/src/usr/local/www/load_balancer_virtual_server.php
@@ -33,10 +33,7 @@ require_once("filter.inc");
 require_once("shaper.inc");
 require_once("vslb.inc");
 
-if (!is_array($config['load_balancer']['virtual_server'])) {
-	$config['load_balancer']['virtual_server'] = array();
-}
-
+init_config_arr(array('load_balancer', 'virtual_server'));
 $a_vs = &$config['load_balancer']['virtual_server'];
 
 $pconfig = $_POST;
diff --git a/src/usr/local/www/load_balancer_virtual_server_edit.php b/src/usr/local/www/load_balancer_virtual_server_edit.php
index c6fc400435..c09e26ade5 100644
--- a/src/usr/local/www/load_balancer_virtual_server_edit.php
+++ b/src/usr/local/www/load_balancer_virtual_server_edit.php
@@ -35,15 +35,11 @@ if (isset($_POST['referer'])) {
 	$referer = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '/load_balancer_virtual_server.php');
 }
 
-if (!is_array($config['load_balancer']['virtual_server'])) {
-	$config['load_balancer']['virtual_server'] = array();
-}
-
-if (!is_array($config['load_balancer']['lbpool'])) {
-	$config['load_balancer']['lbpool'] = array();
-}
-
+init_config_arr(array('load_balancer', 'virtual_server'));
 $a_vs = &$config['load_balancer']['virtual_server'];
+init_config_arr(array('load_balancer', 'lbpool'));
+$a_pool = &$config['load_balancer']['lbpool'];
+
 $id = $_REQUEST['id'];
 
 if (isset($id) && $a_vs[$id]) {
diff --git a/src/usr/local/www/pkg.php b/src/usr/local/www/pkg.php
index bb39bac829..013f2a41e7 100644
--- a/src/usr/local/www/pkg.php
+++ b/src/usr/local/www/pkg.php
@@ -125,6 +125,7 @@ if ($_REQUEST['act'] == "del") {
 		}
 	}
 
+	init_config_arr(array('installedpackages', xml_safe_fieldname($pkg['name']), 'config'));
 	$a_pkg = &$config['installedpackages'][xml_safe_fieldname($pkg['name'])]['config'];
 
 	if ($a_pkg[$_REQUEST['id']]) {
diff --git a/src/usr/local/www/pkg_edit.php b/src/usr/local/www/pkg_edit.php
index c0c2fcb6f4..ca62125d89 100644
--- a/src/usr/local/www/pkg_edit.php
+++ b/src/usr/local/www/pkg_edit.php
@@ -95,8 +95,9 @@ if ($config['installedpackages'] && !is_array($config['installedpackages'][xml_s
  *  https://redmine.pfsense.org/issues/7624
  *  https://redmine.pfsense.org/issues/476
  */
-if ($config['installedpackages'] &&
-    (count($config['installedpackages'][xml_safe_fieldname($pkg['name'])]['config']) > 0) &&
+
+init_config_arr(array('installedpackages', xml_safe_fieldname($pkg['name']), 'config'));
+if ((count($config['installedpackages'][xml_safe_fieldname($pkg['name'])]['config']) > 0) &&
     (empty($config['installedpackages'][xml_safe_fieldname($pkg['name'])]['config'][0])) &&
     is_array($config['installedpackages'][xml_safe_fieldname($pkg['name'])]['config'])) {
 	array_shift($config['installedpackages'][xml_safe_fieldname($pkg['name'])]['config']);
@@ -1102,10 +1103,7 @@ foreach ($pkg['fields']['field'] as $pkga) {
 			$size = ($pkga['size'] ? "size=\"{$pkga['size']}\"" : '');
 			$fieldname = $pkga['fieldname'];
 
-			if (!is_array($config['aliases'])) {
-				$config['aliases'] = array();
-			}
-			
+			init_config_arr(array('aliases', 'alias'));
 			$a_aliases = &$config['aliases']['alias'];
 			$addrisfirst = 0;
 			$aliasesaddr = "";
diff --git a/src/usr/local/www/services_acb_settings.php b/src/usr/local/www/services_acb_settings.php
index ce610bd5ed..caf7473087 100644
--- a/src/usr/local/www/services_acb_settings.php
+++ b/src/usr/local/www/services_acb_settings.php
@@ -56,6 +56,8 @@ function index_of_command() {
 }
 
 $croncmd = "/usr/bin/nice -n20 /usr/local/bin/php /usr/local/sbin/execacb.php";
+
+init_config_arr(array('cron', 'item'));
 $a_cron = &$config['cron']['item'];
 $pconfig = $config['system']['acb'];
 
diff --git a/src/usr/local/www/services_captiveportal.php b/src/usr/local/www/services_captiveportal.php
index 8d6abad74b..ccdc6152af 100644
--- a/src/usr/local/www/services_captiveportal.php
+++ b/src/usr/local/www/services_captiveportal.php
@@ -54,11 +54,8 @@ if (empty($cpzone) || empty($config['captiveportal'][$cpzone])) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal'));
+$a_cp = &$config['captiveportal'];
 
 $pgtitle = array(gettext("Services"), gettext("Captive Portal"), $a_cp[$cpzone]['zone'], gettext("Configuration"));
 $pglinks = array("", "services_captiveportal_zones.php", "@self", "@self");
@@ -126,17 +123,11 @@ if ($_REQUEST['act'] == "viewhtml") {
 	exit;
 }
 
-if (!is_array($config['ca'])) {
-	$config['ca'] = array();
-}
-
-$a_ca =& $config['ca'];
-
-if (!is_array($config['cert'])) {
-	$config['cert'] = array();
-}
+init_config_arr(array('ca'));
+$a_ca = &$config['ca'];
 
-$a_cert =& $config['cert'];
+init_config_arr(array('cert'));
+$a_cert = &$config['cert'];
 
 if ($a_cp[$cpzone]) {
 	$cpzoneid = $pconfig['zoneid'] = $a_cp[$cpzone]['zoneid'];
@@ -319,7 +310,8 @@ if ($_POST['save']) {
 	}
 
 	if (!$input_errors) {
-		$newcp =& $a_cp[$cpzone];
+		init_config_arr(array('captiveportal', $cpzone));
+		$newcp = &$a_cp[$cpzone];
 		//$newcp['zoneid'] = $a_cp[$cpzone]['zoneid'];
 		if (empty($newcp['zoneid'])) {
 			$newcp['zoneid'] = 2;
diff --git a/src/usr/local/www/services_captiveportal_filemanager.php b/src/usr/local/www/services_captiveportal_filemanager.php
index 1175bd7a79..d688e57b97 100644
--- a/src/usr/local/www/services_captiveportal_filemanager.php
+++ b/src/usr/local/www/services_captiveportal_filemanager.php
@@ -57,22 +57,14 @@ if (empty($cpzone)) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal', $cpzone, 'element'));
+$a_cp = &$config['captiveportal'];
+$a_element = &$a_cp[$cpzone]['element'];
 
 $pgtitle = array(gettext("Services"), gettext("Captive Portal"), $a_cp[$cpzone]['zone'], gettext("File Manager"));
 $pglinks = array("", "services_captiveportal_zones.php", "services_captiveportal.php?zone=" . $cpzone, "@self");
 $shortcut_section = "captiveportal";
 
-if (!is_array($a_cp[$cpzone]['element'])) {
-	$a_cp[$cpzone]['element'] = array();
-}
-
-$a_element =& $a_cp[$cpzone]['element'];
-
 // Calculate total size of all files
 $total_size = 0;
 for ($i = 0; $i < count($a_element); $i++) {
diff --git a/src/usr/local/www/services_captiveportal_hostname.php b/src/usr/local/www/services_captiveportal_hostname.php
index 9372df7669..b9ba5736b4 100644
--- a/src/usr/local/www/services_captiveportal_hostname.php
+++ b/src/usr/local/www/services_captiveportal_hostname.php
@@ -49,11 +49,9 @@ if (empty($cpzone) || empty($config['captiveportal'][$cpzone])) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal', $cpzone, 'allowedhostname'));
+$a_cp = &$config['captiveportal'];
+$a_allowedhostnames = &$a_cp[$cpzone]['allowedhostname'];
 
 if (isset($cpzone) && !empty($cpzone) && isset($a_cp[$cpzone]['zoneid'])) {
 	$cpzoneid = $a_cp[$cpzone]['zoneid'];
@@ -64,7 +62,6 @@ $pglinks = array("", "services_captiveportal_zones.php", "services_captiveportal
 $shortcut_section = "captiveportal";
 
 if ($_POST['act'] == "del" && !empty($cpzone)) {
-	$a_allowedhostnames =& $a_cp[$cpzone]['allowedhostname'];
 	if ($a_allowedhostnames[$_POST['id']]) {
 		$ipent = $a_allowedhostnames[$_POST['id']];
 
diff --git a/src/usr/local/www/services_captiveportal_hostname_edit.php b/src/usr/local/www/services_captiveportal_hostname_edit.php
index 99f422b7e4..e2dc716dd3 100644
--- a/src/usr/local/www/services_captiveportal_hostname_edit.php
+++ b/src/usr/local/www/services_captiveportal_hostname_edit.php
@@ -54,11 +54,9 @@ if (empty($cpzone) || empty($config['captiveportal'][$cpzone])) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal', $cpzone, 'allowedhostname'));
+$a_cp = &$config['captiveportal'];
+$a_allowedhostnames = &$a_cp[$cpzone]['allowedhostname'];
 
 $pgtitle = array(gettext("Services"), gettext("Captive Portal"), $a_cp[$cpzone]['zone'], gettext("Allowed Hostnames"), gettext("Edit"));
 $pglinks = array("", "services_captiveportal_zones.php", "services_captiveportal.php?zone=" . $cpzone, "services_captiveportal_hostname.php?zone=" . $cpzone, "@self");
@@ -66,13 +64,6 @@ $shortcut_section = "captiveportal";
 
 $id = $_REQUEST['id'];
 
-
-if (!is_array($a_cp[$cpzone]['allowedhostname'])) {
-	$a_cp[$cpzone]['allowedhostname'] = array();
-}
-
-$a_allowedhostnames = &$a_cp[$cpzone]['allowedhostname'];
-
 if (isset($id) && $a_allowedhostnames[$id]) {
 	$pconfig['zone'] = $a_allowedhostnames[$id]['zone'];
 	$pconfig['hostname'] = $a_allowedhostnames[$id]['hostname'];
diff --git a/src/usr/local/www/services_captiveportal_ip.php b/src/usr/local/www/services_captiveportal_ip.php
index d55a8d31aa..7140c028a4 100644
--- a/src/usr/local/www/services_captiveportal_ip.php
+++ b/src/usr/local/www/services_captiveportal_ip.php
@@ -46,11 +46,8 @@ if (empty($cpzone) || empty($config['captiveportal'][$cpzone])) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal'));
+$a_cp = &$config['captiveportal'];
 
 if (isset($cpzone) && !empty($cpzone) && isset($a_cp[$cpzone]['zoneid'])) {
 	$cpzoneid = $a_cp[$cpzone]['zoneid'];
@@ -61,7 +58,8 @@ $pglinks = array("", "services_captiveportal_zones.php", "services_captiveportal
 $shortcut_section = "captiveportal";
 
 if ($_POST['act'] == "del" && !empty($cpzone)) {
-	$a_allowedips =& $config['captiveportal'][$cpzone]['allowedip'];
+	init_config_arr(array('captiveportal', $cpzone, 'allowedip'));
+	$a_allowedips = &$config['captiveportal'][$cpzone]['allowedip'];
 
 	if ($a_allowedips[$_POST['id']]) {
 		$ipent = $a_allowedips[$_POST['id']];
diff --git a/src/usr/local/www/services_captiveportal_ip_edit.php b/src/usr/local/www/services_captiveportal_ip_edit.php
index c94bca83da..4256ff3b1f 100644
--- a/src/usr/local/www/services_captiveportal_ip_edit.php
+++ b/src/usr/local/www/services_captiveportal_ip_edit.php
@@ -54,23 +54,15 @@ if (empty($cpzone) || empty($config['captiveportal'][$cpzone])) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal', $cpzone, 'allowedip'));
+$a_cp = &$config['captiveportal'];
+$a_allowedips = &$config['captiveportal'][$cpzone]['allowedip'];
 
 $pgtitle = array(gettext("Services"), gettext("Captive Portal"), $a_cp[$cpzone]['zone'], gettext("Allowed IP Addresses"), gettext("Edit"));
 $pglinks = array("", "services_captiveportal_zones.php", "services_captiveportal.php?zone=" . $cpzone, "services_captiveportal_ip.php?zone=" . $cpzone, "@self");
 $shortcut_section = "captiveportal";
 $id = $_REQUEST['id'];
 
-if (!is_array($config['captiveportal'][$cpzone]['allowedip'])) {
-	$config['captiveportal'][$cpzone]['allowedip'] = array();
-}
-
-$a_allowedips =& $config['captiveportal'][$cpzone]['allowedip'];
-
 if (isset($id) && $a_allowedips[$id]) {
 	$pconfig['ip'] = $a_allowedips[$id]['ip'];
 	$pconfig['sn'] = $a_allowedips[$id]['sn'];
diff --git a/src/usr/local/www/services_captiveportal_mac.php b/src/usr/local/www/services_captiveportal_mac.php
index b767dc9d39..7698e04d54 100644
--- a/src/usr/local/www/services_captiveportal_mac.php
+++ b/src/usr/local/www/services_captiveportal_mac.php
@@ -47,11 +47,9 @@ if (empty($cpzone) || empty($config['captiveportal'][$cpzone])) {
 	exit;
 }
 
-if (!is_array($config['captiveportal'])) {
-	$config['captiveportal'] = array();
-}
-
-$a_cp =& $config['captiveportal'];
+init_config_arr(array('captiveportal', $cpzone, 'passthrumac'));
+$a_cp = &$config['captiveportal'];
+$a_passthrumacs = &$a_cp[$cpzone]['passthrumac'];
 
 $pgtitle = array(gettext("Services"), gettext("Captive Portal"), $a_cp[$cpzone]['zone'], gettext("MACs"));
 $pglinks = array("", "services_captiveportal_zones.php", "services_captiveportal.php?zone=" . $cpzone, "@self");
@@ -81,20 +79,11 @@ if ($_POST['save']) {
 	}
 
 	if ($_POST['postafterlogin']) {
-		if (!is_array($a_passthrumacs)) {
+		if (empty($a_passthrumacs)) {
 			echo gettext("No entry exists yet!") ."\n";
 			exit;
 		}
 
-		if (empty($_POST['zone'])) {
-			echo gettext("Please set the zone on which the operation should be allowed");
-			exit;
-		}
-		if (!is_array($a_cp[$cpzone]['passthrumac'])) {
-			$a_cp[$cpzone]['passthrumac'] = array();
-		}
-		$a_passthrumacs =& $a_cp[$cpzone]['passthrumac'];
-
 		if ($_POST['username']) {
 			$mac = captiveportal_passthrumac_findbyname($_POST['username']);
 			if (!empty($mac)) {
@@ -131,8 +120,6 @@ if ($_POST['save']) {
 }
 
 if ($_POST['act'] == "del") {
-	$a_passthrumacs =& $a_cp[$cpzone]['passthrumac'];
-
 	if ($a_passthrumacs[$_POST['id']]) {
 		$cpzoneid = $a_cp[$cpzone]['zoneid'];
 		$rules = captiveportal_passthrumac_delete_entry($a_passthrumacs[$_POST['id']]);
